module DomoscioRails
  class Resource
    class << self
      def class_name
        name.split('::')[-1]
      end

      def url(id = nil, util_name = nil, on_self = nil)
        raise NotImplementedError, 'Resource is an abstract class. Do not use it directly.' if self == Resource

        build_url = "/v#{DomoscioRails.configuration.version}/instances/#{DomoscioRails.configuration.client_id}"
        unless on_self
          build_url << "/#{underscore(class_name)}s"
          build_url << "/#{util_name}" if util_name
          build_url << "/#{CGI.escape(id.to_s)}" if id
        end
        build_url
      end

      def underscore(string)
        string.gsub(/::/, '/')
              .gsub(/([A-Z]+)([A-Z][a-z])/, '\1_\2')
              .gsub(/([a-z\d])([A-Z])/, '\1_\2')
              .tr('-', '_')
              .downcase
      end
    end
  end
end
